﻿Imports System.Data.Linq
Imports System.Data.Linq.Mapping

' Add a reference to system.data.linq. This is a Windows Phone-specific version of LINQ, in the assembly
' C:\%ProgramFiles%\Reference Assemblies\Microsoft\Framework\Silverlight\v4.0\Profile\WindowsPhone71\system.data.linq.dll

Public Class MangoDataContext
    Inherits DataContext
    ' We can only create a database in isolated storage.
    ': base("Data Source=appdata:/Mangolicious.sdf;File Mode=read only;")
    Public Sub New()
        MyBase.New("Data Source=isostore:/Mangolicious.sdf")
    End Sub

    Public Recipes As Table(Of Recipe)
    Public Facts As Table(Of Fact)
    Public Cocktails As Table(Of Cocktail)
End Class


#Region "Recipes"

<Table()>
Public Class Recipe

    Private _id As Integer
    <Column(IsPrimaryKey:=True, IsDbGenerated:=True, DbType:="INT NOT NULL Identity", CanBeNull:=False, AutoSync:=AutoSync.OnInsert)>
    Public Property ID() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            If _id <> value Then
                _id = value
            End If
        End Set
    End Property


    Private _name As String
    <Column(DbType:="NVARCHAR(32)")>
    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            If _name <> value Then
                _name = value
            End If
        End Set
    End Property

    Private _photo As String
    <Column(DbType:="NVARCHAR(255)")>
    Public Property Photo() As String
        Get
            Return _photo
        End Get
        Set(ByVal value As String)
            If _photo <> value Then
                _photo = value
            End If
        End Set
    End Property


    Private _ingredients As String
    <Column(DbType:="NVARCHAR(512)")>
    Public Property Ingredients() As String
        Get
            Return _ingredients
        End Get
        Set(ByVal value As String)
            If _ingredients <> value Then
                _ingredients = value
            End If
        End Set
    End Property


    Private _instructions As String
    <Column(DbType:="NVARCHAR(1024)")>
    Public Property Instructions() As String
        Get
            Return _instructions
        End Get
        Set(ByVal value As String)
            If _instructions <> value Then
                _instructions = value
            End If
        End Set
    End Property


    Private _season As String
    <Column(DbType:="NVARCHAR(8)")>
    Public Property Season() As String
        Get
            Return _season
        End Get
        Set(ByVal value As String)
            If _season <> value Then
                _season = value
            End If
        End Set
    End Property
End Class

#End Region


#Region "Facts"

<Table()>
Public Class Fact

    Private _id As Integer
    <Column(IsPrimaryKey:=True, IsDbGenerated:=True, DbType:="INT NOT NULL Identity", CanBeNull:=False, AutoSync:=AutoSync.OnInsert)>
    Public Property ID() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            If _id <> value Then
                _id = value
            End If
        End Set
    End Property


    Private _name As String
    <Column(DbType:="NVARCHAR(32)")>
    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            If _name <> value Then
                _name = value
            End If
        End Set
    End Property

    Private _photo As String
    <Column(DbType:="NVARCHAR(255)")>
    Public Property Photo() As String
        Get
            Return _photo
        End Get
        Set(ByVal value As String)
            If _photo <> value Then
                _photo = value
            End If
        End Set
    End Property

    Private _body As String
    <Column(DbType:="NVARCHAR(1024)")>
    Public Property Body() As String
        Get
            Return _body
        End Get
        Set(ByVal value As String)
            If _body <> value Then
                _body = value
            End If
        End Set
    End Property
End Class

#End Region


#Region "Cocktails"

<Table()>
Public Class Cocktail
    Private _id As Integer
    <Column(IsPrimaryKey:=True, IsDbGenerated:=True, DbType:="INT NOT NULL Identity", CanBeNull:=False, AutoSync:=AutoSync.OnInsert)>
    Public Property ID() As Integer
        Get
            Return _id
        End Get
        Set(ByVal value As Integer)
            If _id <> value Then
                _id = value
            End If
        End Set
    End Property

    Private _name As String
    <Column(DbType:="NVARCHAR(32)")>
    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            If _name <> value Then
                _name = value
            End If
        End Set
    End Property

    Private _photo As String
    <Column(DbType:="NVARCHAR(255)")>
    Public Property Photo() As String
        Get
            Return _photo
        End Get
        Set(ByVal value As String)
            If _photo <> value Then
                _photo = value
            End If
        End Set
    End Property

    Private _ingredients As String
    <Column(DbType:="NVARCHAR(512)")>
    Public Property Ingredients() As String
        Get
            Return _ingredients
        End Get
        Set(ByVal value As String)
            If _ingredients <> value Then
                _ingredients = value
            End If
        End Set
    End Property

    Private _instructions As String
    <Column(DbType:="NVARCHAR(1024)")>
    Public Property Instructions() As String
        Get
            Return _instructions
        End Get
        Set(ByVal value As String)
            If _instructions <> value Then
                _instructions = value
            End If
        End Set
    End Property

    Private _season As String
    <Column(DbType:="NVARCHAR(8)")>
    Public Property Season() As String
        Get
            Return _season
        End Get
        Set(ByVal value As String)
            If _season <> value Then
                _season = value
            End If
        End Set
    End Property
End Class

#End Region

