﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics

Public Class Player
    ' Animation representing the player,
    Public PlayerAnimation As Animation

    ' Position of the Player relative to the upper left side of the screen,
    Public Position As Vector2

    Public Active As Boolean
    Public Health As Integer

    Public ReadOnly Property Width() As Integer
        Get
            Return PlayerAnimation.FrameWidth
        End Get
    End Property

    Public ReadOnly Property Height() As Integer
        Get
            Return PlayerAnimation.FrameHeight
        End Get
    End Property

    ' Initialize the player.
    Public Sub Initialize(ByVal animation As Animation, ByVal position As Vector2)
        PlayerAnimation = animation
        Me.Position = position
        Active = True
    End Sub

    ' Update the player animation.
    Public Sub Update(ByVal totalTime As TimeSpan, ByVal elapsedTime As TimeSpan)
        PlayerAnimation.Position = Position
        PlayerAnimation.Update(totalTime, elapsedTime)
    End Sub

    ' Draw the player.
    Public Sub Draw(ByVal spriteBatch As SpriteBatch)
        PlayerAnimation.Draw(spriteBatch)
    End Sub
End Class