﻿Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls


Partial Public Class MainPage
    Inherits PhoneApplicationPage

#Region "Init"

    Public Sub New()
        InitializeComponent()
        DataContext = App.ViewModel
    End Sub

#End Region


#Region "OnNavigatedTo"

    Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
        SeasonalPanoItem.Header = App.ViewModel.Season & " highlights"
        CategoryList.SelectedIndex = -1
        CategoryList.ItemsSource = App.ViewModel.Categories
        SeasonalList.SelectedIndex = -1
        SeasonalList.ItemsSource = App.ViewModel.SeasonalHighlights
    End Sub

#End Region


#Region "SelectionChanged"

    Private Sub CategoryList_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        Select Case CategoryList.SelectedIndex
            Case 0
                App.ViewModel.LoadRecipes()
                NavigationService.Navigate(New Uri("/RecipesPage.xaml", UriKind.Relative))
            Case 1
                App.ViewModel.LoadFacts()
                NavigationService.Navigate(New Uri("/FactsPage.xaml", UriKind.Relative))
            Case 2
                App.ViewModel.LoadCocktails()
                NavigationService.Navigate(New Uri("/CocktailsPage.xaml", UriKind.Relative))
            Case 3
                NavigationService.Navigate(New Uri("/GamePage.xaml", UriKind.Relative))
        End Select
    End Sub

    Private Sub SeasonalList_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        ' When the user selects an item from the seasonal highlights list,
        ' we must identify which table/page to navigate to, as well as which item.
        If SeasonalList.SelectedIndex <> -1 Then
            Dim selectedItem As SeasonalHighlight = CType(SeasonalList.SelectedItem, SeasonalHighlight)
            Dim navigationString As String = String.Empty
            If selectedItem.SourceTable = "Recipes" Then
                App.ViewModel.LoadRecipes()
                navigationString = String.Format("/RecipePage.xaml?ID={0}", selectedItem.ID)
            ElseIf selectedItem.SourceTable = "Cocktails" Then
                App.ViewModel.LoadCocktails()
                navigationString = String.Format("/CocktailPage.xaml?ID={0}", selectedItem.ID)
            End If
            NavigationService.Navigate(New System.Uri(navigationString, UriKind.Relative))
        End If
    End Sub

#End Region

End Class